/*
 * @author Phil Zoio
 */
package co.uk.realsolve.holiday.jsfbeans;

import java.util.Date;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.ValidatorException;

/**
 * 
 */
public class NewHoliday extends Base
{

    /** *************** fields ******************* */

    Date date;

    float amount;

    String reference;

    String description;

    /** *************** getters and setters ******************* */

    public float getAmount()
    {
        return amount;
    }

    public void setAmount(float amount)
    {
        this.amount = amount;
    }

    public Date getDate()
    {
        return date;
    }

    public void setDate(Date date)
    {
        this.date = date;
    }

    public String getDescription()
    {
        return description;
    }

    public void setDescription(String description)
    {
        this.description = description;
    }

    public String getReference()
    {
        return reference;
    }

    public void setReference(String reference)
    {
        this.reference = reference;
    }

    /** *************** public service methods ******************* */

    public String submitNewHoliday()
    {
        getHolidayService().addHoliday(amount, date, description);
        return "success";
    }

    /** *************** validation via backing bean (instead of validator) ******************* */

    public void validateDate(FacesContext context, UIComponent component, Object value)
    {
        if (!isValid((Date)value))
        {
            FacesMessage message = new FacesMessage("Invalid date" + value + ": must be format yyyy-mm-dd");
            throw new ValidatorException(message);
        }
    }

    private boolean isValid(Date value)
    {
        System.out.println("Value: " + value + ", class: " + value.getClass().getName());
        if (value == null) return false;
        return true;
    }

}